#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct balans
{
	char ime[50];
	char tip_rada[50];
	char kategorija_rada[50];
	int bal;
	struct balans *levi, *desni;
} BALANS;

int dubina(BALANS *p)
{
	int dl=0,dd=0;
	if(p)
	{
		if(p->levi) dl=dubina(p->levi);
		if(p->desni) dd=dubina(p->desni);
		if(dl>dd) return ++dl;
		else return ++dd;
	}
	else return 0;
}

BALANS *lrotacija(BALANS *p)
{
	BALANS *pom;
	pom=p->desni->levi;
	p->desni->levi=p;
	p=p->desni;
	p->levi->desni=pom;
	
	p->levi->bal=dubina(p->levi->desni)-dubina(p->levi->levi);
	p->bal=dubina(p->desni)-dubina(p->levi);
	return p;
}
BALANS *drotacija(BALANS *p)
{
	BALANS *pom;
	
	pom=p->levi->desni;
	p->levi->desni=p;
	p=p->levi;
	p->desni->levi=pom;
	
	p->desni->bal=dubina(p->desni->desni)-dubina(p->desni->levi);
	p->bal=dubina(p->desni)-dubina(p->levi);
	
	return p;
}

int Proveri(BALANS *p, BALANS *temp)
{
	if(p->tip_rada[0]=='n')
	return 1;
	else
	if(temp->tip_rada[0]=='r' && temp->kategorija_rada[2]=='1')
	return 1;
	else
	if(temp->tip_rada[0]=='m' && (p->tip_rada[0]=='n' || p->tip_rada[0]=='m' || (p->tip_rada[0]=='r' && p->kategorija_rada[2]=='2')))
	return 1;
	else
	if(temp->tip_rada[0]=='r' && temp->kategorija_rada[2]=='2' && ((p->tip_rada[0]=='r' && p->kategorija_rada[2]=='2') || (p->tip_rada[0]=='n')))
	return 1;
	return 0;
}

int Dodaj(BALANS **p2, BALANS *temp)
{
	BALANS *p;
	p=*p2;
	int rezultat,ink;
	
	rezultat=0;
	
	if(p==NULL)
	{
		p=temp;
		p->levi=NULL;p->desni=NULL;
		p->bal=0;
		rezultat=1;
	}
	else
	{
		if(Proveri(p,temp))
		ink=Dodaj(&(p->desni),temp);
		else
		ink=-Dodaj(&(p->levi),temp);
		p->bal+=ink;
		if(ink != 0 && p->bal != 0)
		{
			if(p->bal<-1)
			{
				if(p->levi->bal<0)
				{
					p=drotacija(p);
				}
				else
				{
					p->levi=lrotacija(p->levi);
					p=drotacija(p);
				}
			}
			else
			if(p->bal>1)
			{
				if(p->desni->bal>0)
				{
					p=lrotacija(p);
				}
				else
				{
					p->desni=drotacija(p->desni);
					p=lrotacija(p);
				}
			}
			else rezultat=1;
		}
	}
	(*p2)=p;
	return rezultat;
}

void Kreiraj(BALANS **p2)
{
	BALANS *p;
	BALANS *temp;
	
	int n,i;
	
	p=(*p2);
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++)
	{
		temp=malloc(sizeof(BALANS));
		gets(temp->ime);
		gets(temp->tip_rada);
		if(strcmp(temp->tip_rada,"rad")==0) gets(temp->kategorija_rada);
		else
		strcpy(temp->kategorija_rada,"");
		Dodaj(&p,temp);
	}
	(*p2)=p;
}

void Ispis(BALANS *p)
{
	if(p != NULL)
	{
		Ispis(p->levi);
		printf("%s %s %s Balans<%d>\n",p->ime,p->tip_rada,p->kategorija_rada,p->bal);
		Ispis(p->desni);
	}
}

BALANS *Brisi(BALANS *p, BALANS *novo)
{
	if(p != NULL)
	{
		novo=Brisi(p->levi,novo);
		novo=Brisi(p->desni,novo);
		
		p->levi=p->desni=NULL;
		if(strcmp(p->tip_rada,"nema")!=0)
		Dodaj(&novo,p);
		else free(p);
	}
	return novo;
}

int brojac(BALANS *p, int *br, int *br2)
{
	if(p != NULL)
	{
		brojac(p->levi,br,br2);
		brojac(p->desni,br,br2);
		if(strcmp(p->tip_rada,"monografija")==0)
		(*br)++;
		else
		if(p->tip_rada[0]=='r' && strcmp(p->kategorija_rada,"M21")==0)
		(*br2)++;
	}
	
	if((*br)==(*br2)) return 0;
	else
	if((*br)>(*br2)) return 1;
	else return 2;
}

main()
{
	BALANS *p=NULL;
	int br,br1=0,br2=0;
	Kreiraj(&p);
	Ispis(p);
	printf("\n");
	p=Brisi(p,NULL);
	Ispis(p);
	br=brojac(p,&br1,&br2);
	if(br==0) printf("Ima isti broj naucnih radnika\n");
	else
	if(br==1) printf("Ima vise sa monografijom\n");
	else printf("Ima vise sa M21\n");
}
