#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define noviString(x) x = (char*)malloc(sizeof(char))
#define novaStruktura(x) x = (struct n*)malloc(sizeof(struct n))

typedef struct n
{
	char *ime;
	char *tipRada;
	char *kategorija;
	int balans;
	struct n *levi, *desni;
}naucnik;

void lrotacija(naucnik **n)
{
	naucnik *pomd, *poml = *n;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*n = pomd;

	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
}

void drotacija(naucnik **n)
{
	naucnik *pomd = *n, *poml;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*n = poml;

	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
}

int dubina(naucnik *n)
{
	int dl = 0;
	int dd = 0;
	if(n)
	{
		if(n->levi) dl = dubina(n->levi);
		if(n->desni) dd = dubina(n->desni);
		if(dl > dd)
		return ++dl;
		else return ++dd;
	}
	else return 0;
}

naucnik* unos()
{
	char *imeN, *tipR,*katR;
	
	naucnik *temp;

	novaStruktura(temp);
	noviString(imeN);
	noviString(tipR);	
	noviString(katR);

	printf("Unesi ime: \n");
	gets(imeN);
	temp->ime = (char*)malloc(strlen(imeN)+1);
	strcpy(temp->ime,imeN);
	
	printf("Unesi tip rada: \n");
	scanf("%s", tipR);
	temp->tipRada = (char*)malloc(strlen(tipR)+1);
	strcpy(temp->tipRada, tipR);

	if(strcmp(temp->tipRada, "rad") == 1)
	{
		printf("Unesi kategoriju rada: \n");
		scanf("%s", katR);
		temp->kategorija = (char*)malloc(strlen(katR)+1);
		strcpy(temp->kategorija, katR);
	}
	temp->levi = temp->desni = NULL;
	temp->balans = 0;
	return temp;
}

int dodaj(naucnik **n, naucnik *temp)
{
	int rezultat = 0, inkrement;
	naucnik *pom = *n;
	if (!pom)
	{
		pom = temp;
		rezultat = 1;
	}
	else
	{
		if((strcmp(pom->kategorija,"M21") == 1) && (strcmp(temp->kategorija,"M21") == 0)) inkrement = -dodaj(&(pom->levi), temp);
		else if((strcmp(pom->tipRada,"monografija") == 1)&&(strcmp(temp->tipRada,"rad") == 1)) inkrement = -dodaj(&(pom->levi), temp);
		else if(strcmp(temp->tipRada,"nema") == 1) inkrement = -dodaj(&(pom->levi), temp);//handle jos
		pom->balans += inkrement;
		if (pom->balans != 0 && inkrement != 0)
		{
			if(pom->balans < -1)
			{
				if(pom->levi->balans < 0) drotacija(&pom);
				else
				{
					lrotacija(&(pom->levi));
					drotacija(&pom);				
				}
			}
			if(pom->balans > 1)
			{
				if(pom->desni->balans > 0) lrotacija(&pom);
				else
				{
					drotacija(&(pom->desni));
					lrotacija(&pom);				
				}
			}
		}
		else rezultat = 1;
	}
	*n = pom;
	return rezultat;
}

naucnik* form()
{
	int i,broj;
	naucnik *temp, *koren = NULL;
	printf("Unesi bro naucnika: \n");
	scanf("%d", &broj);
	for(i = 0; i<broj; i++)
	{
		temp = unos();
		dodaj(&koren, temp);
	}
}

void fix(naucnik **n)
{
	naucnik *t;
	if(*n)
	{
		t = *n;
		if(t->balans < -1)
		{
			if(t->levi->balans < 0) drotacija(&t);
			else
			{
				lrotacija(&(t->levi));
				drotacija(&t);				
			}
		}
		if(t->balans > 1)
		{
			if(t->desni->balans > 0) lrotacija(&t);
			else
			{
				drotacija(&(t->desni));
				lrotacija(&t);				
			}
		}
		*n = t;
	}
}


naucnik *find(naucnik **n)
{
	naucnik *pom,*res;
	pom = *n;
	if(!(pom->levi))
	{
		res = pom;
		pom = pom->desni;
	}
	else
	{
		res = find(&(pom->levi));
	}
	if(pom)
	{
		pom->balans = dubina(pom->desni) - dubina(pom->levi);
		fix(&pom);
	}
	*n = pom;
	return res;
}


naucnik* delete(naucnik *n)
{
	naucnik *pom,*t;
	if (!n)
	return NULL;
	if(!(strcmp(n->tipRada, "nema")))
	{
		if(!(n->levi) && (!(n->desni)))
		{
			free(n);
			return NULL;
		}
		if(!(n->levi) && (n->desni))
		{	
			pom = n->desni;
			free(n);
			return pom;
		}
		if((n->levi) && (!(n->desni)))
		{	
			pom = n->levi;
			free(n);
			return pom;
		}
		if (n->levi && n->desni)
		{
			t = find(&(n->desni));
			strcpy(n->ime,t->ime);
			strcpy(n->tipRada,t->tipRada);
			strcpy(n->kategorija,t->kategorija);

			n->balans = dubina(n->desni) - dubina(n->levi);
			fix(&n);
			return n;
		}
	}
	n->levi = delete(n->levi);
	n->balans = dubina(n->desni) - dubina(n->levi);
	n->desni = delete(n->desni);
	fix(&n);
	return n;
}

void ispis(naucnik *n)
{
	if(n)
	{
		if(n->desni) ispis(n->desni);
		printf("%s\n", n->ime);
		printf("%s\n", n->tipRada);
		printf("%s\n", n->kategorija);
		if(n->levi) ispis(n->levi);
	}
}

main()
{
	naucnik *n;
	n = form();
	ispis(n);
}
