#include <stdio.h>
#include <string.h>
#include <stdlib.h>

enum{crvena,crna};

struct drvo{
	int boja;
	char ime[50], tip_rada[50], kategorija[50];
	struct drvo *levi, *desni, *roditelj;
};

#define novi(x) x=(struct drvo *)malloc(sizeof(struct drvo))

void print(struct drvo *p)
{
	if(p)
	{
		print(p->desni);
		printf("%s\t", p->ime);
		printf("%s\t", p->tip_rada);
		if(p->kategorija) printf("%s\t", p->kategorija);
		print(p->levi);
	}
	printf("\n");
}

int ko_gde(struct drvo *p1, struct drvo *p2)
{
	if((p2->kategorija) && !strcmp(p2->kategorija,"M21"))
		return 1;
	if(!strcmp(p2->tip_rada,"monografija"))
		if((p1->kategorija) && (!strcmp(p1->kategorija,"M21")))
			return 0;
		else
			return 1; 
	if((p2->kategorija) && !strcmp(p2->kategorija,"M22"))
		if((!strcmp(p1->tip_rada,"nema")) && ((p1->kategorija) && !strcmp(p1->kategorija,"M22")))
			return 1;
		else
			return 0;
	if(!strcmp(p2->tip_rada,"nema"))
		if(!strcmp(p1->tip_rada,"nema"))
			return 1;
		else
			return 0;
}

void lrotacija(struct drvo **p)
{
	struct drvo *x, *y;
	
	x=*p;
	y=x->desni;
	x->desni=y->levi;
	if(y->levi) y->levi->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
		if(x==x->roditelj->levi) x->roditelj->levi=y;
		else x->roditelj->desni=y;
	y->levi=x;
	x->roditelj=y;
	*p=y;
}

void drotacija(struct drvo **p)
{
	struct drvo *x, *y;
	
	x=*p;
	y=x->levi;
	x->levi=y->desni;
	if(y->desni) y->desni->roditelj=x;
	y->roditelj=x->roditelj;
	if(x->roditelj)
		if(x==x->roditelj->levi) x->roditelj->levi=y;
		else x->roditelj->desni=y;
	y->desni=x;
	x->roditelj=y;
	*p=y;
}

void bojefix(struct drvo **p, struct drvo *x)
{
	struct drvo *y, *t;
	
	while((x->roditelj) && (x->roditelj->boja==crvena))
	{
		if(x->roditelj==x->roditelj->roditelj->levi)
		{
			y=x->roditelj->roditelj->desni;
			if((y) && (y->boja==crvena))
			{
				y->boja=crna;
				x->roditelj->boja=crna;
				x->roditelj->roditelj=crvena;
				x=x->roditelj->roditelj;
			}
			else
			{
				if(x==x->roditelj->desni)
				{
					x=x->roditelj;
					lrotacija(&x);
					if(!x->roditelj) *p=x;
					x=x->levi;
				}
				x->roditelj->boja=crna;
				x->roditelj->roditelj->boja=crvena;
				t=x->roditelj->roditelj;
				drotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
		else
		{
			y=x->roditelj->roditelj->levi;
			if((y) && (y->boja==crvena))
			{
				y->boja=crna;
				x->roditelj->boja=crna;
				x->roditelj->roditelj=crvena;
				x=x->roditelj->roditelj;
			}
			else
			{
				if(x==x->roditelj->levi)
				{
					x=x->roditelj;
					drotacija(&x);
					if(!x->roditelj) *p=x;
					x=x->desni;
				}
				x->roditelj->boja=crna;
				x->roditelj->roditelj->boja=crvena;
				t=x->roditelj->roditelj;
				lrotacija(&t);
				if(!t->roditelj) *p=t;
			}
		}
	}
	(*p)->boja=crna;
}

void dodaj(struct drvo **p, struct drvo *k)
{
	struct drvo *x, *y=NULL;
	
	x=*p;
	
	if(x)
	{
		y=x;
		if(ko_gde(x,k)) x=x->desni;
		else x=x->levi;
	}
	k->roditelj=y;
	if(!y) *p=k;
	else
		if(ko_gde(y,k)) y->desni=k;
		else y->levi=k;
	bojefix(p,k);
}

struct drvo *form(void)
{
	struct drvo *p=NULL, *temp;
	int n, i;
	char s[50];
	
	scanf("%d",&n);
	getchar();
	
	for(i=0;i<n;i++)
	{
		novi(temp);
		temp->levi=temp->desni=NULL;
		temp->boja=crvena;
		
		gets(s);
		strcpy(temp->ime,s);
		
		gets(s);
		strcpy(temp->tip_rada,s);
		if(!strcmp(temp->tip_rada,"rad"))
		{
			gets(s);
			strcpy(temp->kategorija,s);
		}
		dodaj(&p,temp);
	}
	return p;
}

void brisi(struct drvo **p, struct drvo *q)
{
	struct drvo *temp;
	
	if(q)
	{
		if(strcmp(q->tip_rada,"nema"))
		{
			novi(temp);
			strcmp(temp->ime,q->ime);
			strcmp(temp->tip_rada,q->tip_rada);
			if(q->kategorija) strcmp(temp->kategorija,q->kategorija);
			temp->levi=temp->desni=temp->roditelj=NULL;
			temp->boja=crvena;
			dodaj(p,temp);
			brisi(p,q->levi);
			brisi(p,q->desni);
		}
		else
		{
			brisi(p,q->desni);
		}
	}
	else return;
}

void koga_vise(struct drvo *p, int *n, int *m)
{
	if(p)
	{
		koga_vise(p->levi,n,m);
		
		if(!strcmp(p->tip_rada,"monografija")) (*m)++;
		if((p->kategorija) && (!strcmp(p->kategorija,"m21"))) (*n)++;
		
		koga_vise(p->desni,n,m);
	}
}

main()
{
	struct drvo *p, *q=NULL;
	int n=0, m=0;
	
	p=form();
	
	print(p);
	
	brisi(&q,p);
	
	print(q);
	
	koga_vise(q,&n,&m);
	
	if(n<m) printf("Vise sa naucnim radom!\n");
	else if(n>m) printf("Vise sa monografijom!\n");
	else printf("Jednako!\n");
}


























