#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct Naucnik {
	char *IME;
	char *TIP_RADA;
	char *KATEGORIJA_RADA;
	int balans;
	struct Naucnik *levi, *desni;
}naucnik;

#define novi(x) x =(naucnik*)malloc(sizeof(naucnik))

int dubina(naucnik *p) {
	int dd = 0, dl = 0;
	
	if(p) {
		if(p->levi) dl = dubina(p->levi);
		if(p->desni) dd = dubina(p->desni);
		if(dl > dd) return ++dl;
		else return ++dd;
	}else return 0;
}

void lrotacija(naucnik **t) {
	naucnik *poml, *pomd;
	poml = *t;
	pomd = poml->desni;
	poml->desni = pomd->levi;
	pomd->levi = poml;
	*t = pomd;
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

void drotacija(naucnik **t) {
	naucnik *poml, *pomd;
	pomd = *t;
	poml = pomd->levi;
	pomd->levi = poml->desni;
	poml->desni = pomd;
	*t = poml;
	poml->balans = dubina(poml->desni) - dubina(poml->levi);
	pomd->balans = dubina(pomd->desni) - dubina(pomd->levi);
}

int vrednosti(char *tiprada, char *kategorijarada) {
	
	if(strcmp(tiprada,"monografija")) return 2;
	else if(strcmp(tiprada,"rad")) {
		if(strcmp(kategorijarada,"M21")) return  3;
		else if(strcmp(kategorijarada,"M22")) return 1; 
	}
	else if(strcmp(tiprada,"nema")) return 0;
}


int dodaj(naucnik **p, char *ime, char *tip, char *kategorija) {
		int rezultat=0, inkrement;
		naucnik *t = *p;
		if(!t) {
			novi(t);
			if(!t)
				perror("Greska");
			t->IME=(char*)malloc(strlen(ime)+1);
			strcpy(t->IME,ime);
			t->TIP_RADA=(char*)malloc(strlen(tip)+1);
			strcpy(t->TIP_RADA,tip);
			t->KATEGORIJA_RADA=(char*)malloc(strlen(kategorija)+1);
			strcpy(t->KATEGORIJA_RADA,kategorija);
			t->balans = 0;
			t->levi = t->desni = NULL;
			rezultat = 1;
		} 
		else {
			if(vrednosti(tip,kategorija) >= vrednosti(t->TIP_RADA,t->KATEGORIJA_RADA)) inkrement = dodaj(&(t->desni),ime,tip,kategorija);
			else inkrement = -dodaj(&(t->levi),ime,tip,kategorija);
			t->balans += inkrement;
			if(inkrement!=0 && t->balans !=0) 
			{
				if(t->balans<-1)
				{
					if(t->levi->balans < 0) drotacija(&t);
					else
					{
						lrotacija(&(t->levi));
						drotacija(&t);
					}
				}
				else if(t->balans>1)
				{
					if(t->desni->balans > 0) lrotacija(&t);
					else
					{
						drotacija(&(t->desni));
						lrotacija(&t);
					}
				}
				else rezultat = 1;
			}
		}
		*p = t;
		return rezultat;
}

void ispis(naucnik *p)
{
	if(p)
	{
		ispis(p->levi);
		printf("%s\n",p->IME);
		printf("%s\n",p->TIP_RADA);
		printf("%s\n",p->KATEGORIJA_RADA);
		printf("%d\n",p->balans);
		ispis(p->desni);
	}
}


void brisi(naucnik *p, naucnik **q)
{
	if(p) {
		brisi(p->levi,q);
		if(strcmp(p->TIP_RADA,"nema")!=0) dodaj(q,p->IME,p->TIP_RADA,p->KATEGORIJA_RADA);
		brisi(p->desni,q);
	}
}

void vise(naucnik *p,int *mon,int *rad)
{
		if(p)
		{
			vise(p->levi,mon,rad);
			if(strcmp(p->TIP_RADA,"monografija")==0) (*mon)++;
			else if(strcmp(p->TIP_RADA,"rad")==0 && (strcmp(p->KATEGORIJA_RADA,"M21")==0)) (*rad)++;
			vise(p->desni,mon,rad);
		}
}
main() {
	naucnik *p = NULL;
	naucnik *q = NULL;
	int n,i, mo =0, ra =0;
	char ime[50],tip[50],kat[50];
	scanf("%d",&n);
	getchar();
	for(i=0;i<n;i++)
	{
		gets(ime);
		gets(tip);
		gets(kat);
		dodaj(&p,ime,tip,kat);
	}
	ispis(p);
	brisi(p,&q);
	printf("Posle brisanja\n");
	ispis(q);
	vise(q,&mo,&ra);
	if(mo > ra) printf("Vise ima monografija\n");
	else if(ra > mo) printf("Vise ima naucnih radova\n");
	else printf("Ima ih podjednako\n");
}
