#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct node
{
	char* naziv;
	int udaljenost;
	char okretnica[3];
	struct node *next, *prev;
} node;

void add(node** p, node** q, char* naziv, int udaljenost, char* okretnica)
{
	node* r;
	r = (node*)malloc(sizeof(node));
	r->next = r->prev = NULL;
	r->naziv = (char*)malloc((strlen(naziv) + 1) * sizeof(char));
	strcpy(r->naziv, naziv);
	r->udaljenost = udaljenost;
	strcpy(r->okretnica, okretnica);
	
	if(!(*p))
		*p = *q = r;
	else
	{
		r->prev = *q;
		(*q)->next = r;
		*q = r;
	}

}

void form(node** p, node **q)
{
	int n;
	char naziv[30];
	int udaljenost;
	char okretnica[3];
	scanf("%d",&n);
	getchar();
	while(n)
	{
		gets(naziv);
		scanf("%d",&udaljenost);
		getchar();
		gets(okretnica);
		add(p,q,naziv,udaljenost,okretnica);
		n--;
	}
}

void print(node* p)
{
	while(p)
	{
		printf("%s\t%d\t%s\n",p->naziv,p->udaljenost,p->okretnica);
		p = p->next;
	}
}

//proverava da li je M pre ili posle K u odnosu na Beograd
int ispred(node* p, char* m, char *k)
{
	node *r,*s;
	r = p;
	
	while(r)
	{
		if(!strcmp(r->naziv, k))
		{
			s = r->next;
			while(s)
			{
				if(!strcmp(s->naziv, m))
					return 1;
				s = s->next;
			}
			return 0;	
		}
		r = r->next;
	}
}

int km(node* p, node *q, char* m, char *k)
{
	node *r, *s;
	int i,j,l;
	int km = 0;
	int ispr = ispred(p,m,k);

	r = p;
	if(ispr == 1)
	{
		while((r) && (strcmp(m,r->naziv)))
		{
			km += r->udaljenost;
			r = r->next;
		}
		if(r)
			km += r->udaljenost;
			
		if((r) && (!strcmp(r->okretnica, "DA")))
		{
			while((r) && (strcmp(r->naziv, k)))
			{
				km += r->udaljenost;
				r = r->prev;
			}
		}
		else
		{
			r = r->next;
			while((r) && (!strcmp(r->okretnica, "NE")))
			{
				km += r->udaljenost;
				r = r->next;
			}
			km += r->udaljenost;
			while((r) && (strcmp(r->naziv, k)))
			{
				km += r->udaljenost;
				r = r->prev;
			}			
		}		
	}
	else
	{
		while((r) && (strcmp(k,r->naziv)))
		{
			km += r->udaljenost;
			r = r->next;
		}
		km += r->udaljenost;
	}
	
	
	return km;
}




int main(void)
{
	node *p = NULL, *q = NULL;
	char m[30];
	char k[30];
	form(&p,&q);
	print(p);

	printf("Unesi mesto kuce:\n");
	gets(k);
	printf("%s\n",k);
	printf("Unesi mesto gde se svraca: \n");

	gets(m);
		printf("%s\n",m);
	printf("%d\n\n",km(p,q,m,k));
}

